#!/usr/bin/perl -w
#
# Created by Steve Hammond May 2006
#
# This CGI Perl script show the status of the blocked and watched hosts created by Blockhosts 1.0.4.
#
# Change the fileyou use with Blockhosts if it is not the default of /etc/hosts.allow
#

$file = "/etc/hosts.allow";

#
#You should not change anything passed this line unless you know what your doing!
#

sub trim($);
sub blocked($);

print "Content-type: text/html\n\n";
print "<b><font size=4>Host.allow file</b><br><br>Status of IP addresses</font><br><br><table style=\"width: 100%; text-align: center; margin-left: auto; margin-right: auto;\" border=\"1\" cellpadding=\"2\" cellspacing=\"2\"><tbody>";
my @File = "";
open(HostsAllow,$file) || die "can't open file\n";

@File = <HostsAllow>;
close (HostsAllow);
$BlockedFlag = 0;
$BHTag = 0;
my @BlockedHosts;
my $EntryNbr = 0;
print "<tr style=\"background-color: rgb(153, 51, 153);\"><td style=\"width: 120px;\">Entry nbr</td><td style=\"width: 120px;\">IP</td><td style=\"width: 100px;\">Number</td><td style=\"width: 120px;\">Last date</td><td style=\"width: 120px;\">Last time</td><td style=\"width: 120px;\">Status</td></tr>";
print "\n";
for (@File)
{
	if (!$BlockedFlag)
	{
		$BlockedFlag = 1 if (m/---- BlockHosts Additions/);
	}
	elsif ($BlockedFlag && !$BHTag)
	{
		if (m/bh: ip:/)
		{
			pop(@BlockedHosts);
			$BHTag = 1;
			#s/#bh: ip: / /;
			$IP = substr($_,8,17);
			$IP = trim($IP);
			$count = substr($_,27,4);
			$date = substr($_,33,10) if (substr($_,43,1) eq "-");
			$date = substr($_,33,11) if (substr($_,43,1) ne "-");
			$hour = substr($_,44);
			$_ = $hour;
			s/-/:/;
			$hour = $_;
			$EntryNbr++;
			if (blocked($IP))
			{
				print "<tr style=\"background-color: rgb(255, 0, 0);\"><td>$EntryNbr</td><td>$IP</td><td>$count</td><td>$date</td><td>$hour</td><td>Blocked</td></tr>";
			}
			else
			{
				print "<tr style=\"background-color: rgb(255, 255, 0);\"><td>$EntryNbr</td><td>$IP</td><td>$count</td><td>$date</td><td>$hour</td><td>Watched</td></tr>";
			}
			
		}
		else
		{
			s/ALL: / /;
			s/ : deny/ /;
			$temp = trim($_);
			push(@BlockedHosts,$temp);
		}
	}
	elsif ($BHTag)
	{
		if (m/bh: ip:/)
		{
			$IP = substr($_,8,16);
			$IP = trim($IP);
			$count = substr($_,27,4);
			$date = substr($_,33,10) if (substr($_,43,1) eq "-");
			$date = substr($_,33,11) if (substr($_,43,1) ne "-");
			$hour = substr($_,45) if (substr($_,44,1) eq "-");
			$hour = substr($_,44) if (substr($_,44,1) ne "-");
			$_ = $hour;
			s/-/:/;
			$hour = $_;
			$EntryNbr++;
			if (blocked($IP))
			{
				print "<tr style=\"background-color: rgb(255, 0, 0);\"><td>$EntryNbr</td><td>$IP</td><td>$count</td><td>$date</td><td>$hour</td><td>Blocked</td></tr>";
			}
			else
			{
				print "<tr style=\"background-color: rgb(255, 255, 0);\"><td>$EntryNbr</td><td>$IP</td><td>$count</td><td>$date</td><td>$hour</td><td>Watched</td></tr>";
			}
		}
		else
		{
			last;
		}
	}
#	print "\n";
}
print "</tbody></table>";


sub trim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}

sub blocked($)
{
	my $ip = shift;
	foreach(@BlockedHosts)
	{
		return 1 if ($_ eq $ip);
	}
return 0;
}